#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>
#include <string.h>
#include <time.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) { \
            perror(userMsg);\
            exit(EXIT_FAILURE); \
        } \
    } while (0)

#define RD_END   (0)
#define WR_END   (1)
#define BUF_SIZE    (1024)

int main(int argc, char** argv) {
    
    checkError(argc == 2, "args");

    int fd = open(argv[1], O_RDONLY);
    checkError(fd != -1, "open");

    int x;
    int retVal = 0;
    while ((retVal = read(fd, &x, sizeof(int))) > 0) {

        printf("Message: %d\n", x);
    }
    checkError(retVal != -1, "read");

    close(fd);
    
    exit(EXIT_SUCCESS);
}