#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include <stdio.h>
#include <stdlib.h>

#include <sys/wait.h>
#include <string.h>
#include <time.h>

#include <errno.h>

#define checkError(expr,userMsg) \
    do { \
        if (!(expr)) { \
            perror(userMsg);\
            exit(EXIT_FAILURE); \
        } \
    } while (0)

#define RD_END   (0)
#define WR_END   (1)
#define BUF_SIZE    (1024)

int main(int argc, char** argv) {
    
    checkError(argc == 3, "args");

    struct stat fInfo;
    // checkError(stat(argv[1], &fInfo) != -1, "stat");
    // int retVal = stat(argv[1], &fInfo);
    // if (retVal == -1) {
    //     if (errno == ENOENT) {
            
    //         int pravaPristupa = strtol(argv[2], NULL, 8);
    //         checkError(mkfifo(argv[1], pravaPristupa) != -1, "mkfifo");
    //     }
    //     else {
    //         checkError(0, "stat");
    //     }
    // }

    int pravaPristupa = strtol(argv[2], NULL, 8);
    int retVal = mkfifo(argv[1], pravaPristupa);
    if (retVal == -1 && errno != EEXIST) {
        checkError(0, "mkfifo");
    }
    
    int fd = open(argv[1], O_WRONLY | O_TRUNC);
    checkError(fd != -1, "open");

    srand(time(NULL));
    int x;
    char response[BUF_SIZE];

    do {
        x = rand();
        printf("Message sent: %d\n", x);
        checkError(write(fd, &x, sizeof(int)) != -1, "write");
        printf("Send next?(yes|no)");
        scanf("%s", response);

    } while (strcmp(response,"no"));

    close(fd);

    exit(EXIT_SUCCESS);
}